//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3DAF00EE0335.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3DAF00EE0335.cm

//## begin module%3DAF00EE0335.cp preserve=no
//## end module%3DAF00EE0335.cp

//## Module: PlotDelchi%3DAF00EE0335; Package body
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Commands/PlotDelchi.cxx

//## begin module%3DAF00EE0335.additionalIncludes preserve=no
//## end module%3DAF00EE0335.additionalIncludes

//## begin module%3DAF00EE0335.includes preserve=yes
#include <XSPlot/Plot/CreateBinnedPlotGroups.h>
#include <XSPlot/Plot/PlotGroup.h>
#include <XSPlot/Plot/PlotSettings.h>
#include <XSPlot/Plot/PlotStyle.h>
#include <XSPlot/Plot/PlotTypes.h>

#include <XSFit/Fit/Fit.h>
#include <XSFit/Fit/StatMethod.h>
#include <XSContainer.h>
//## end module%3DAF00EE0335.includes

// PlotDelchi
#include <XSPlot/Commands/PlotDelchi.h>
//## begin module%3DAF00EE0335.declarations preserve=no
//## end module%3DAF00EE0335.declarations

//## begin module%3DAF00EE0335.additionalDeclarations preserve=yes
//## end module%3DAF00EE0335.additionalDeclarations


// Class PlotDelchi 

PlotDelchi::PlotDelchi()
  //## begin PlotDelchi::PlotDelchi%3DAEFC580104_const.hasinit preserve=no
  //## end PlotDelchi::PlotDelchi%3DAEFC580104_const.hasinit
  //## begin PlotDelchi::PlotDelchi%3DAEFC580104_const.initialization preserve=yes
  : PlotCommand("delchi", new CreateBinnedPlotGroups(false, false))
  //## end PlotDelchi::PlotDelchi%3DAEFC580104_const.initialization
{
  //## begin PlotDelchi::PlotDelchi%3DAEFC580104_const.body preserve=yes
   isDataRequired(true);
   isActiveModelRequired(true);
   isDivisibleByArea(false);
   addCompLevel(0);
   isBackgroundApplicable(false);
   
   PlotAttributes styles;
   styles.symbolStyle = PlotCommand::standardDataStyle();
   styles.lineStyle = PlotStyle::NONE;
   setStyleMap(PlotStyle::DATA, styles);
   
  //## end PlotDelchi::PlotDelchi%3DAEFC580104_const.body
}


PlotDelchi::~PlotDelchi()
{
  //## begin PlotDelchi::~PlotDelchi%3DAEFC580104_dest.body preserve=yes
  //## end PlotDelchi::~PlotDelchi%3DAEFC580104_dest.body
}



//## Other Operations (implementation)
void PlotDelchi::manipulate (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotDelchi::manipulate%4B1FDDE4009C.body preserve=yes
   const StatMethod* stat = XSContainer::fit->statMethod();
   const Real NO_VAL = settings.badDataValue();
   for (size_t i=0; i<plotGroups.size(); ++i)
   {
      PlotGroup* pg = plotGroups[i];
      size_t arraySize = pg->n;
      std::vector<Real>& yData  = pg->yData.data;
      std::vector<Real>& yError = pg->yData.errors[0];
      const std::vector<Real>& model  = pg->model[0].data;
      for (size_t j=0; j<arraySize; ++j)
      {
         Real obs = yData[j];
         Real mod = model[j];
         Real err = yError[j];
         yData[j]  = stat->plotDeltaChi(obs,mod,err,NO_VAL);
         yError[j] = 1.;
      }
   }
  //## end PlotDelchi::manipulate%4B1FDDE4009C.body
}

void PlotDelchi::setRanges (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotDelchi::setRanges%4B1FDDE903B2.body preserve=yes
   Real xlow=0.0, xhigh=0.0;
   PlotGroupCreator::determineXRange(plotGroups,&xlow,&xhigh);
  
   PlotRange& rangeVals = rangeSettings();
   rangeVals.ranges.x1 = xlow;
   rangeVals.ranges.x2 = xhigh;
   if (settings.xOption() == CHANNELS)
      rangeVals.xScaleType = PlotStyle::LINEAR;
   else 
      rangeVals.xScaleType = settings.xLog() ? PlotStyle::LOG :
                PlotStyle::LINEAR;
   
   rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX;
   
   // Draw a horizontal line at y = 0.0
   rangeVals.horizontalLine.first = true;
   rangeVals.horizontalLine.second = 0.0;
  //## end PlotDelchi::setRanges%4B1FDDE903B2.body
}

void PlotDelchi::makeLabels (const PlotSettings& settings, StandardLabels& labels) const
{
  //## begin PlotDelchi::makeLabels%4B1FDDF000A0.body preserve=yes
  settings.makeXOptionDependentLabel(labels.x);
  labels.y = settings.lookupLabelName("y:delchi");
  labels.title = settings.lookupLabelName("t:delchi");
  //## end PlotDelchi::makeLabels%4B1FDDF000A0.body
}

// Additional Declarations
  //## begin PlotDelchi%3DAEFC580104.declarations preserve=yes
  //## end PlotDelchi%3DAEFC580104.declarations

//## begin module%3DAF00EE0335.epilog preserve=yes
//## end module%3DAF00EE0335.epilog
